#global svnrev	12803

%global _smp_ncpus_max	8

%define major		0
%define libname		%mklibname %{name} %{major}
%define develname	%mklibname %{name} -d

%global __provides_exclude_from ^%{_libdir}/%{name}/plugins/.*\\.so$

Name:		codeblocks
Version:	25.03%{?svnrev:^svn%svnrev}
Release:	%mkrel 1
Summary:	A C++ IDE
Group:		Development/Other
License:	GPLv3
URL:		https://www.codeblocks.org/
%if 0%{?svnrev:1}
Source0:	%{name}-svn%{svnrev}.tar.bz2
%else
Source0:	https://downloads.sourceforge.net/codeblocks/%{name}_%{version}.tar.xz
%endif
Source1:	%{name}.png
Source100:	getsources.sh
Patch1:		codeblocks-autorev.patch
Patch2:		codeblocks-wxBitmapBundle.patch
BuildRequires:	zip
BuildRequires:	dos2unix
BuildRequires:	imagemagick
BuildRequires:	astyle-devel
BuildRequires:	boost-devel
BuildRequires:	wxgtk-devel
BuildRequires:	squirrel-devel
BuildRequires:	pkgconfig(bzip2)
BuildRequires:	pkgconfig(hunspell)
BuildRequires:	pkgconfig(gamin)
BuildRequires:	pkgconfig(fontconfig)
BuildRequires:	pkgconfig(tinyxml)
BuildRequires:	pkgconfig(zlib)

Recommends:	gcc-c++

%description
Code::Blocks is a free C++ IDE built specifically to meet the most demanding
needs of its users. It was designed, right from the start, to be extensible and
configurable. Built around a plugin framework, Code::Blocks can be extended
with plugin DLLs. It includes a plugin wizard so you can compile your own
plugins!

%package -n	%{libname}
Summary:	Shared library for %{name}
Group:		System/Libraries

%description -n	%{libname}
Shared libraries for %{name}.

%package -n	%{develname}
Summary:	Development headers for %{name}
Group:		Development/C
Requires:	%{libname} = %{version}
Provides:	%{name}-devel = %{version}-%{release}

%description -n	%{develname}
Development headers for %{name}.

%prep
%autosetup -n %{name}_%{?svnrev:svn%svnrev}%{?!svnrev:%version} -p1

%if 0%{?svnrev:1}
# replace egrep with grep -E
perl -pi -e 's,egrep,grep -E,g' bootstrap

# generate revision.m4
cat >> revision.m4 << EOF
m4_define([SVN_REV], %{svnrev})
m4_define([SVN_REVISION], %(echo %{version} | tr -d '^'))
m4_define([SVN_DATE], %(TZ=GMT date '+%F %T'))
EOF
%endif

%build
%if 0%{?svnrev:1}
./bootstrap
%else
autoreconf -fi
%endif
%configure \
	--with-contrib-plugins=all \
	--with-boost-libdir=%{_libdir} \
	--disable-static

%make_build

%install
%make_install

mkdir -p %{buildroot}%{_iconsdir}/hicolor/{128x128,256x256}/apps
convert -scale 128x128 %{SOURCE1} %{buildroot}%{_iconsdir}/hicolor/128x128/apps/%{name}.png
install -m 0644 %{SOURCE1} %{buildroot}%{_iconsdir}/hicolor/256x256/apps/%{name}.png

chmod +x %{buildroot}%{_datadir}/%{name}/lexers/lexer_bash.sample

%files
%doc README AUTHORS BUGS COMPILERS TODO NEWS
%{_bindir}/*
%{_libdir}/%{name}/
%{_datadir}/applications/%{name}.desktop
%{_datadir}/%{name}/
%{_iconsdir}/hicolor/*/*/*.png
%{_datadir}/mime/packages/%{name}.xml
%{_datadir}/pixmaps/%{name}.png
%{_metainfodir}/%{name}.appdata.xml
%{_metainfodir}/%{name}-contrib.metainfo.xml
%{_mandir}/man1/*.1*

%files -n %{libname}
%doc README
%{_libdir}/lib*.so.%{major}{,.*}

%files -n %{develname}
%doc BUGS COMPILERS TODO
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc
%{_includedir}/*


%changelog
* Tue Apr 01 2025 daviddavid <daviddavid> 25.03-1.mga10
+ Revision: 2172523
- new version: 25.03

* Sun Jun 25 2023 wally <wally> 20.03^svn12803-4.mga10
+ Revision: 1963012
- limit parallel builds

* Fri Jul 15 2022 wally <wally> 20.03^svn12803-3.mga9
+ Revision: 1868983
- rebuild for wxgtk 3.2.0

* Sun Jun 12 2022 wally <wally> 20.03^svn12803-2.mga9
+ Revision: 1864088
- rebuild for wxgtk 3.1.7

* Sat Apr 30 2022 wally <wally> 20.03^svn12803-1.mga9
+ Revision: 1855274
- update to latest upstream svn snapshot
- rebuild for wxgtk 3.1.6
- rebuild for wxgtk 3.1.6

* Sun Apr 03 2022 umeabot <umeabot> 20.03-9.mga9
+ Revision: 1842875
- Mageia 9 Mass Rebuild

* Sat Jan 15 2022 wally <wally> 20.03-8.mga9
+ Revision: 1768493
- rebuild for wxgtk 3.1.5 with working wxSizer::SetSizeHints()

* Sat Jan 01 2022 wally <wally> 20.03-7.mga9
+ Revision: 1765897
- add upstream patch to fix build with gcc11
- fix build with C++17
- rebuild for wxgtk 3.1.5 to resolve 'Symbol X has different size in shared object, consider re-linking' error

* Fri Apr 16 2021 daviddavid <daviddavid> 20.03-6.mga9
+ Revision: 1716077
- rebuild for final wxgtk 3.1.5

* Tue Apr 06 2021 daviddavid <daviddavid> 20.03-5.mga9
+ Revision: 1713902
- add upstream patch to don't call wxChoice::GetString() with wxNOT_FOUND
  * applied patch #1079 (thanks Miguel Gimenez) (mga#28722)

* Fri Jan 01 2021 wally <wally> 20.03-4.mga8
+ Revision: 1667691
- rebuild for wxgtk pre 3.1.5 snapshot

* Mon Aug 17 2020 wally <wally> 20.03-3.mga8
+ Revision: 1614621
- rebuild for new wxgtk 3.1.4

* Wed Apr 01 2020 daviddavid <daviddavid> 20.03-2.mga8
+ Revision: 1562857
- add upstream patch to fix armv7 build

* Mon Mar 30 2020 daviddavid <daviddavid> 20.03-1.mga8
+ Revision: 1562388
- new version: 20.03
- switch to wxgtk3 + gtk+3

* Fri Feb 14 2020 umeabot <umeabot> 17.12-5.mga8
+ Revision: 1520481
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Fri Nov 23 2018 daviddavid <daviddavid> 17.12-4.mga7
+ Revision: 1333468
- rebuild for new hunspell 1.7.0

* Tue Oct 16 2018 wally <wally> 17.12-3.mga7
+ Revision: 1321018
- rebuild for new boost 1.68.0

* Sun Sep 23 2018 umeabot <umeabot> 17.12-2.mga7
+ Revision: 1296639
- Mageia 7 Mass Rebuild

* Mon Jan 01 2018 daviddavid <daviddavid> 17.12-1.mga7
+ Revision: 1188586
- new version: 17.12

* Thu Oct 19 2017 daviddavid <daviddavid> 16.01-3.mga7
+ Revision: 1172788
- rebuild for new gcc7 (mga#21861)

* Sun Aug 06 2017 daviddavid <daviddavid> 16.01-2.mga7
+ Revision: 1137573
- rebuild for new libhunspell 1.6

* Thu Jul 28 2016 daviddavid <daviddavid> 16.01-1.mga6
+ Revision: 1043826
- new version: 16.01 (mga#19061)

* Thu Apr 21 2016 tv <tv> 13.12-7.mga6
+ Revision: 1004208
- rebuid for libhunspell 1.4

* Sun Feb 14 2016 umeabot <umeabot> 13.12-6.mga6
+ Revision: 959809
- Mageia 6 Mass Rebuild

* Thu Sep 17 2015 akien <akien> 13.12-5.mga6
+ Revision: 880250
- Rebuild for gcc 5.2.1

* Wed Oct 15 2014 umeabot <umeabot> 13.12-4.mga5
+ Revision: 741743
- Second Mageia 5 Mass Rebuild

* Thu Sep 18 2014 umeabot <umeabot> 13.12-3.mga5
+ Revision: 693653
- Rebuild to fix library dependencies

* Tue Sep 16 2014 umeabot <umeabot> 13.12-2.mga5
+ Revision: 678462
- Mageia 5 Mass Rebuild
+ tv <tv>
- s/uggests:/Recommends:/

* Wed Aug 13 2014 vaci0 <vaci0> 13.12-1.mga5
+ Revision: 662137
- Update new version 13.12-1
- Clean spec file
+ fwang <fwang>
- new version 13.12

* Sat Oct 19 2013 umeabot <umeabot> 12.11-3.mga4
+ Revision: 529380
- Mageia 4 Mass Rebuild

* Tue Jul 09 2013 fwang <fwang> 12.11-2.mga4
+ Revision: 451713
- rebuild for new boost

* Tue Jun 04 2013 dams <dams> 12.11-1.mga4
+ Revision: 437241
- new version 12.11
- remove merged and useless patches
- add BR: hunspell-devel, gamin-devel, libboost-devel
- add a better icon as %%Source1 for better rendering in menu
- clean specfile

* Fri Jan 11 2013 umeabot <umeabot> 10.05-6.mga3
+ Revision: 347966
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Dec 25 2012 pterjan <pterjan> 10.05-5.mga3
+ Revision: 334999
- Steal patches from Fedora
 * Use system squirrel and tinyxml
 * Add D support (from upstream)
 * Fix build
- Do not use wx-config-unicode which no longer exists

* Wed Sep 21 2011 fwang <fwang> 10.05-4.mga2
+ Revision: 146372
- drop .la files
+ ahmad <ahmad>
- Rebuild against wxgtk2.8 with enabled catch_segvs

* Thu Mar 24 2011 ennael <ennael> 10.05-2.mga1
+ Revision: 76879
- clean spec file
- imported package codeblocks


* Sat Sep 18 2010 Funda Wang <fwang@mandriva.org> 10.05-2mdv2011.0
+ Revision: 579500
- rebuild
- drop unused lines

* Wed Aug 04 2010 Funda Wang <fwang@mandriva.org> 10.05-1mdv2011.0
+ Revision: 565643
- new version 10.05
- all patches have been merged upstream

  + Emmanuel Andry <eandry@mandriva.org>
    - suggests gcc-c++

* Mon Jan 11 2010 Funda Wang <fwang@mandriva.org> 8.02-3mdv2010.1
+ Revision: 489781
- sync with fedora patches

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild

  + Oden Eriksson <oeriksson@mandriva.com>
    - lowercase ImageMagick

* Thu Aug 07 2008 Thierry Vignaud <tv@mandriva.org> 8.02-2mdv2009.0
+ Revision: 266537
- rebuild early 2009.0 package (before pixel changes)

  + Pixel <pixel@mandriva.com>
    - rpm filetriggers deprecates update_menus/update_scrollkeeper/update_mime_database/update_icon_cache/update_desktop_database/post_install_gconf_schemas
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Fri May 02 2008 Adam Williamson <awilliamson@mandriva.org> 8.02-1mdv2009.0
+ Revision: 199981
- buildrequires imagemagick
- drop all the autotools stuff, it's not needed
- remove all the excess junk from description
- clean file list
- reorder spec
- clean spec

  + Nicolas Lécureuil <nlecureuil@mandriva.com>
    - New version 8.02

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Sat Dec 08 2007 Nicolas Lécureuil <nlecureuil@mandriva.com> 1.0-0.rc2.1mdv2008.1
+ Revision: 116483
- Fix BR
- Fix Group
- import codeblocks


