#!/bin/bash

url="svn://svn.code.sf.net/p/codeblocks/code/trunk"

curdir=$(pwd)
tmpdir=$(mktemp -d)

if [ $# -eq 1 ]; then
  rev=$1
else
  rev=$(svn info --show-item revision ${url})
fi

pushd ${tmpdir}
  LANG=C TZ=GMT svn export --quiet ${url} -r ${rev} codeblocks-svn${rev}
  if [ -x ${curdir}/codeblocks-svn${rev}.tar.bz2 ]; then
    rm -rf ${curdir}/codeblocks-svn${rev}.tar.bz2
  fi
  tar cjvf ${curdir}/codeblocks-svn${rev}.tar.bz2 codeblocks-svn${rev}
popd

rm -rf ${tmpdir}
